package net.wanji.utc.dt.cache;

import net.wanji.databus.dao.entity.CrossSchedulesPO;
import net.wanji.databus.dto.PlanSectionDTO;
import net.wanji.databus.dto.SchemePhaseLightsDTO;
import net.wanji.databus.po.CrossInfoPO;
import net.wanji.databus.vo.PlanSectionVO;
import net.wanji.databus.vo.SchemePhaseLightsVO;
import net.wanji.utc.dt.service.StaticInfoService;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @author duanruiming
 * @date 2023/07/05 16:23
 */
@Component
@Order(2)
public class StartQueryStaticInfo implements CommandLineRunner {

    @Resource(name = "commonThreadPoolExecutor")
    ThreadPoolTaskExecutor commonThreadPoolExecutor;
    @Resource
    StaticInfoService staticInfoService;

    @Override
    public void run(String... args) throws Exception {
        try {
            Map<String, CrossInfoPO> crossInfoMap = CrossInfoCache.getCrossInfoCache();
            if (!crossInfoMap.isEmpty()) {
                for (Map.Entry<String, CrossInfoPO> entry : crossInfoMap.entrySet()) {
                    commonThreadPoolExecutor.execute(() -> {
                        try {
                            String crossId = entry.getKey();
                            List<CrossSchedulesPO> crossSchedulesPOS = staticInfoService.crossSchedules(crossId);
                            SchemePhaseLightsDTO schemePhaseLightsDTO = new SchemePhaseLightsDTO();
                            schemePhaseLightsDTO.setCrossId(crossId);
                            SchemePhaseLightsVO schemePhaseLightsVO = staticInfoService.schemePhaseLights(schemePhaseLightsDTO);
                            PlanSectionDTO planSectionDTO = new PlanSectionDTO();
                            planSectionDTO.setCrossId(crossId);
                            List<PlanSectionVO> planSectionVOS = staticInfoService.planSection(planSectionDTO);
                        } catch (Exception e) {
                            throw new RuntimeException("开机启动自动加载静态信息失败", e);
                        }
                    });
                }
            }
        } catch (Exception e) {
            throw new Exception("开机启动自动加载静态信息失败", e);
        }
    }
}
