package net.wanji.utc.dt.common.enums;

import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author duanruiming
 * @date 2023/05/08 10:17
 */
@Getter
public enum CommandResultSignEnum {

    HEARTBEAT("80", "heartBeatService"),
    GET_DEVICE_INFO("0d0120", "getDeviceInfoService"),
    GET_SIGNAL_BASE_INFO("2002","getBaseInfoService"),
    GET_LIGHTS_GROUP_INFO("030220", "getLightsGroupInfoService"),
    GET_LIGHTS_STATUS_INFO("030320", "getLightsStatusInfoService"),
    GET_PHASE_INFO("040220", "getPhaseInfoService"),
    GET_DETECTOR_INFO("2005", "getDetectorInfoService"),
    GET_STAGE_INFO("060220", "getStageInfoService"),
    GET_STAGE_STATUS("060320", "getStageStatusService"),
    GET_PHASE_SECURITY_INFO("2007", "getPhaseSecurityInfoService"),
    GET_SCHEME_INFO("090220", "getSchemeInfoService"),
    GET_DAILY_PLAN_INFO("0b0220", "getDailyPlanInfoService"),
    GET_SCHEDULES_INFO("0c0220", "getSchedulesInfoService"),
    GET_RUNNING_STATE_INFO("0d0220", "getRunningStateInfoService"),
    GET_TRAFFIC_DATA_INFO("2014", "getTrafficDataInfoService"),
    GET_ALARM_INFO("2015", "getAlarmInfoService"),
    GET_FAULT_INFO("100220", "getFaultInfoService"),
    GET_DEVICE_STATUS_INFO("0d0120", "getDeviceStatusService"),

    SET_DEVICE_INFO("3001", "setDeviceInfoService"),
    SET_SIGNAL_BASE_INFO("3002","setBaseInfoService"),
    SET_LIGHTS_GROUP_INFO("3003", "setLightsGroupInfoService"),
    SET_PHASE_INFO("3004", "setPhaseInfoService"),
    SET_DETECTOR_INFO("3005", "setDetectorInfoService"),
    SET_STAGE_INFO("3006", "setStageInfoService"),
    SET_PHASE_SECURITY_INFO("3007", "setPhaseSecurityInfoService"),
    SET_SCHEME_INFO("3009", "setSchemeInfoService"),
    SET_DAILY_PLAN_INFO("0b0240", "setDailyPlanInfoService"),
    SET_SCHEDULES_INFO("090240", "setSchedulesInfoService"),
    SET_TRAFFIC_DATA_INFO("3014", "setTrafficDataInfoService"),
    SET_ALARM_INFO("3015", "setAlarmInfoService"),
    SET_FAULT_INFO("3016", "setFaultInfoService"),
    SET_DEVICE_STATUS_INFO("800160", "setDeviceStatusService"),
    SET_CONTROL_INFO("110140", "setControlInfoService");


    private String hexSign;
    private String className;

    CommandResultSignEnum(String hexSign, String className) {
        this.hexSign = hexSign;
        this.className = className;
    }

    public static String getClassNameByHexSign(String hexSign) {
        if (StringUtils.isEmpty(hexSign)) {
            return null;
        }
        for (CommandResultSignEnum uniqueCommandResultSign : values()) {
            if (uniqueCommandResultSign.hexSign.equals(hexSign)) {
                return uniqueCommandResultSign.className;
            }
        }
        return null;
    }
}
