package net.wanji.utc.dt.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author duanruiming
 * @date 2023/06/19 10:07
 */
@Getter
@AllArgsConstructor
public enum ControlModelEnum {
    FIXED_CYCLE(1, "21", "定周期"),
    GREEN_WAVE(2, "13", "绿波协调"),
    YELLOW_CONTROL(3, "31", "黄闪"),
    RED_CONTROL(4, "32", "全红"),
    CLOSED_CONTROL(5, "33", "关灯"),
    SELF_CONTROL(6, "14", "单点自适应 -> 中心自适应"),
    FULL_INDUCTION(7, "22", "全感应 -> 本地感应"),
    HALF_INDUCTION(8, "", "半感应");

    private Integer wjControl;
    private String dtControlHex;
    private String message;

    public static Integer getWjControlMode(String dtControlHex) {
        for (ControlModelEnum value : ControlModelEnum.values()) {
            if (StringUtils.equals(dtControlHex, value.getDtControlHex())) {
                return value.getWjControl();
            }
        }
        return null;
    }

}
