package net.wanji.utc.dt.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author duanruiming
 * @date 2023/06/19 10:07
 */
@Getter
@AllArgsConstructor
public enum ControlTypeEnum {
    FIXED_CYCLE(1, "0021", "定周期"),
    GREEN_WAVE(2, "0032", "全红"),
    YELLOW_CONTROL(3, "0031", "黄闪"),
    RED_CONTROL(4, "0015", "锁定 --> 中心手动控制"),
    CLOSED_CONTROL(5, "0012", "中心优化"),
    SELF_CONTROL(6, "0013", "MEC优化"),
    FULL_INDUCTION(7, "0021", "现场手动");

    private Integer wjControl;
    private String dtControlHex;
    private String message;

    public static Integer getWjControlType(String dtControlHex) {
        for (ControlTypeEnum value : ControlTypeEnum.values()) {
            if (StringUtils.equals(dtControlHex, value.getDtControlHex())) {
                return value.getWjControl();
            }
        }
        return null;
    }

}
