package net.wanji.utc.dt.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author duanruiming
 * @date 2023/06/19 16:27
 */
@Getter
@AllArgsConstructor
public enum PhaseLightColorEnum {
    LIGHT_OFF("01", "off", "关灯"),

    LIGHT_RED("10", "red", "红灯"),

    LIGHT_RED_FLASH("11", "red", "红闪"),

    LIGHT_RED_FAST_FLASH("12", "red", "红快闪"),

    LIGHT_GREEN("20", "green", "绿灯"),

    LIGHT_GREEN_FLASH("21", "green", "绿闪"),

    LIGHT_GREEN_FAST_FLASH("22", "green", "率快闪"),

    LIGHT_YELLOW("30", "yellow", "黄灯"),

    LIGHT_YELLOW_FLASH("31", "yellow", "黄闪"),

    LIGHT_YELLOW_FAST_FLASH("32", "yellow", "黄快闪"),

    LIGHT_RED_YELLOW("40", "redYellow", "红黄灯");

    private final String dtLightColor;
    private final String wjLightColor;
    private final String message;

    public static String getWjLightColor(String dtLightColor) {
        for (PhaseLightColorEnum value : PhaseLightColorEnum.values()) {
            if (StringUtils.equals(dtLightColor, value.getDtLightColor())) {
                return value.getWjLightColor();
            }
        }
        return null;
    }
}
