package net.wanji.utc.dt.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/06/21 9:31
 */
@Getter
@AllArgsConstructor
public enum SectionControlModeEnum {
    FIXED_CYCLE(1, "21", "定周期"),
    GREEN_WAVE(2, "13", "绿灯"),
    YELLOW_CONTROL(3, "31", "黄灯"),
    RED_CONTROL(4, "32", "红灯"),
    CLOSED_CONTROL(5, "33", "关灯"),
    SELF_CONTROL(6, "14", "绿闪"),
    FULL_INDUCTION(7, "31", "黄闪"),
    HALF_INDUCTION(8, "32", "红闪");

    private final Integer wjControl;
    private final String dtControlHex;
    private final String message;

    public static String getDtControlMode(Integer wjControlHex) {
        for (ControlModelEnum value : ControlModelEnum.values()) {
            if (Objects.equals(wjControlHex, value.getWjControl())) {
                return value.getDtControlHex();
            }
        }
        return null;
    }

}
