package net.wanji.utc.dt.pojo.dtconvert;

import lombok.Data;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/06/14 15:39
 */
@Data
public class SchemeInfoPojo {
    private Integer schemeId;
    // 所属方案序号 一台信号机控制多路口时使用
    private Integer controlCrossId;
    // 单位s
    private Integer cycle;
    // 方案协调序号 需要协调的相位序号
    private Integer harmonizeId;
    private Integer offset;
    private List<Integer> phaseStageChain;
    private List<Integer> phaseStageTimeChain;
    // 10 固定出现 20 检测器按需出现
    private List<Integer> phaseStageTypeChain;

    @Data
    public static class SchemeStagePojo {
        private Integer schemeId;
        private Integer phaseStageId;
        private Integer phaseStageTime;
        private Integer phaseStageType;
    }

    public static List<SchemeStagePojo> getStageInfoList(SchemeInfoPojo schemeInfoPojo) {
        if (Objects.nonNull(schemeInfoPojo)) {
            List<SchemeStagePojo> schemeStagePojos = new ArrayList<>();
            for (int i = 0; i < schemeInfoPojo.getPhaseStageChain().size(); i++) {
                SchemeStagePojo schemeStagePojo = new SchemeStagePojo();
                schemeStagePojo.setSchemeId(schemeInfoPojo.getSchemeId());
                schemeStagePojo.setPhaseStageId(schemeInfoPojo.getPhaseStageChain().get(i));
                schemeStagePojo.setPhaseStageTime(schemeInfoPojo.getPhaseStageTimeChain().get(i));
                schemeStagePojo.setPhaseStageType(schemeInfoPojo.getPhaseStageTypeChain().get(i));
                schemeStagePojos.add(schemeStagePojo);
            }
            return schemeStagePojos;
        }
        return null;
    }
}
