package net.wanji.utc.dt.util;

import cn.hutool.core.util.HexUtil;

/**
 * @author duanruiming
 * @date 2023/05/12 15:26
 */
public class CRC16Utils {

    /**
     * 获取CRC16校验结果 【报文长度+报文体】
     *
     * @param body
     * @return
     */
    public static String getCRC16HexStr(String body) {
        byte[] bytes = HexUtil.decodeHex(body);
        int result = crc16(bytes);
        return HexUtil.toHex(result);
    }

    /**
     * 多项式1005 初始值0000 异或值0000 不反转
     *
     * @param bytes
     * @return
     */
    public static int crc16(byte[] bytes) {
        int crc = 0x0000;

        for (byte b : bytes) {
            crc ^= (b << 8);
            for (int i = 0; i < 8; i++) {
                if ((crc & 0x8000) != 0) {
                    crc = (crc << 1) ^ 0x1005;
                } else {
                    crc = (crc << 1);
                }
            }
        }

        return crc & 0xFFFF;
    }

}
